C 
C  SORTS ALPHANUMERIC ARRAY A INTO INCREASING ORDER. ORDERING IS BY 
C  LOGICAL COMPARISONS. 
C  ARRAYS IU(K) AND IL(K) PERMIT SORTING OF UP TO 2**(K+1)-1 ELEMENTS 
C 
C  INPUT VARIABLE   USE 
C       A           ARRAY TO BE SORTED 
C       N           RECORD LENGTH 
C       NO          NUMBER OF RECORDS TO BE SORTED 
C       F           BYTE NUMBER OF SORT FIELD WITHIN RECORD 
C       FL          NUMBER OF BYTES IN COMPARE FIELD 
C       T,TT        WORK VECTORS OF LENGTH N 
C 
      SUBROUTINE QSORT(A,N,NO,F,FL,T,TT) 
      IMPLICIT INTEGER(A-Z) 
	CHARACTER*(*) A(N), T, TT
      DIMENSION IU(16),IL(16) 
      M=1 
      I=1 
      J=NO 
	FZ=F+FL-1
    5 IF(I.GE.J)GO TO 70
   10 K=I 
      IJ=(J+I)/2 
	T=A(IJ)
	IF(A(I)(F:FZ) .LE. T(F:FZ)) GO TO 20
15	A(IJ)=A(I)
	A(I)=T
	T=A(I)
   20 L=J 
	IF(A(J)(F:FZ) .GE. T(F:FZ)) GO TO 40
25	A(IJ)=A(J)
	A(J)=T
	T=A(IJ)
	IF(A(I)(F:FZ) .LE. T(F:FZ)) GO TO 40
27	A(IJ)=A(I)
	A(I)=T
	T=A(IJ)
      GO TO 40 
30	A(L)=A(K)
	A(K)=TT
   40 L=L-1 
	IF(A(L)(F:FZ) .GT. T(F:FZ)) GO TO 40
45	TT=A(L)
   50 K=K+1 
	IF(A(K)(F:FZ) .LT. T(F:FZ)) GO TO 50
   55 IF(K.LE.L)GO TO 30 
      IF(L-I.LE.J-K)GO TO 60 
      IL(M)=I 
      IU(M)=L 
      I=K 
      M=M+1 
      GO TO 80 
   60 IL(M)=K 
      IU(M)=J 
      J=L 
      M=M+1 
      GO TO 80 
   70 M=M-1 
      IF(M.EQ.0)RETURN 
      I=IL(M) 
      J=IU(M) 
   80 IF(J-I.GE.11)GO TO 10 
      IF(I.EQ.1)GO TO 5 
      I=I-1 
   90 I=I+1 
      IF(I.EQ.J)GO TO 70 
	T=A(I+1)
	IF(A(I)(F:FZ) .LE. T(F:FZ)) GO TO 90
   95 K=I 
100	A(K+1)=A(K)
      K=K-1 
	IF(T(F:FZ) .LT. A(K)(F:FZ)) GO TO 100
105	A(K+1)=T
      GO TO 90 
      END 
