$ ! 
$ ! VAX/VMS system startup - Release 1
$ !
$ SHOW TIME
$ SET NOVERIFY
$ SET NOON
$ !
$ ! Mount the console floppy.
$ !
$ MOUNT /SYSTEM/FOR/PROT=(SYSTEM:RWLP) DX1: CONSOLE
$ SET DEFAULT [SYSEXE]
$ !
$ ! Assign debugger systemwide logical names
$ !
$ ASSIGN/SYSTEM SYS$INPUT: DBG$INPUT:
$ ASSIGN/SYSTEM SYS$OUTPUT: DBG$OUTPUT:
$ !
$ ! Assign FORTRAN systemwide logical names
$ !
$ ASSIGN/SYSTEM SYS$INPUT: FOR005:
$ ASSIGN/SYSTEM SYS$OUTPUT: FOR006:
$ ASSIGN/SYSTEM SYS$INPUT: FOR$ACCEPT:
$ ASSIGN/SYSTEM SYS$INPUT: FOR$READ:
$ ASSIGN/SYSTEM SYS$OUTPUT: FOR$PRINT:
$ ASSIGN/SYSTEM SYS$OUTPUT: FOR$TYPE:
$ !
$ ! Assign systemwide logical names for RSX-11M support
$ !
$ ASSIGN/SYSTEM 'F$LOG("SYS$DISK") LB:
$ ASSIGN/SYSTEM 'F$LOG("SYS$DISK") LB0:
$ ASSIGN/SYSTEM 'F$LOG("SYS$DISK") WK:
$ ASSIGN/SYSTEM 'F$LOG("SYS$DISK") WK0:
$ ASSIGN/SYSTEM 'F$LOG("SYS$DISK") SP:
$ ASSIGN/SYSTEM 'F$LOG("SYS$DISK") SP0:
$ !
$ ! Assign systemwide logical names for libraries and help files
$ !
$ ASSIGN/SYSTEM 'F$LOG("SYS$DISK")[SYSLIB] SYS$LIBRARY:
$ ASSIGN/SYSTEM 'F$LOG("SYS$DISK")[SYSHLP] SYS$HELP:
$ !
$ !	Assign GOULD related nonsence
$ !
$ ASSIGN/SYSTEM DMA1:[107001] SYS$PLOT
$ !
$ !	Install images requiring privilege and those which should be shared.
$ ! The most frequently activated images should be installed last.
$ ! THE .EXE 'QUEMAN' IS INSTALLED WITH OPERATOR PRIV IN ORDER THAT
$ ! ALL USERS CAN START THE PRINT QUEUE 'OPA0' SINCE AT THIS TIME THERE
$ ! IS NO LINEPRINTER.
$ ! 				X/XXX/MCMLXXVIII
$ !
$ RUN SYS$SYSTEM:INSTALL
PRTSMB /OPEN /SHARED
QUEMAN /PRIVILEGED=OPER
BASIC /PRIVILEGED=CMKRNL
WHO /PRIVILEGED=(WORLD,GROUP)
INIT /PRIVILEGED=(CMKRNL,PHY_IO,LOG_IO)
VMOUNT /PRIVILEGED=(CMKRNL,DETACH,LOG_IO,SETPRV,ALTPRI, -
 	TMPMBX,WORLD,GROUP,EXQUOTA,ACNT,PHY_IO,BUGCHK,MOUNT)
DISMOUNT /PRIVILEGED=(CMKRNL,EXQUOTA,BUGCHK)
DISPLAY /PRIVILEGED=(CMKRNL,CMEXEC) /OPEN /HEADER_RESIDENT /SHARED
LOGINOUT /PRIVILEGED=(CMKRNL,CMEXEC,TMPMBX,EXQUOTA)
SET /PRIVILEGED=(CMKRNL,TMPMBX) /OPEN /HEADER_RESIDENT /SHARED
SHOW /PRIVILEGED=(CMKRNL,TMPMBX,NETMBX) /OPEN /HEADER_RESIDENT /SHARED
PIP /OPEN
SOS /OPEN /SHARED
!
!	Install RSXSHR sharable image before the executable images,
!	RSX and BACKTRANS, which link with it.
!
SYS$LIBRARY:RSXSHR /OPEN /SHARED
RSX /OPEN /HEADER_RESIDENT /SHARED
BACKTRANS /OPEN /HEADER_RESIDENT /SHARED
!
! Make the debugger shared
!
SYS$LIBRARY:DEBUG /OPEN /SHARED
!
! Make TRACE shared if desired
!
! SYS$LIBRARY:TRACE /OPEN /SHARED
!
!
! Make the Common Run Time Library shared
!
SYS$LIBRARY:VMSRTL /OPEN /SHARED
!
! Make CRF a shareable image if desired.
!
! SYS$LIBRARY:CRFSHR /OPEN /SHARED
$ !
$ !	Automatically configure I/O data base to include all
$ !	standard devices and their required drivers.
$ !
$ RUN SYS$SYSTEM:SYSGEN
AUTOCONFIGURE ALL /SELECT=(DM,TT,CR,LP)
LOAD DM0:[1,35]DPDRIVER.EXE
CONNECT DPA0/ADAPTER=3/VECTOR=%O154/CSR=%O4200
CONNECT DPA1/ADAPTER=3/VECTOR=%O154/CSR=%O4200
CONNECT DPA2/ADAPTER=3/VECTOR=%O154/CSR=%O4200
CONNECT DPA3/ADAPTER=3/VECTOR=%O154/CSR=%O4200
CONNECT DPA4/ADAPTER=3/VECTOR=%O154/CSR=%O4200
CONNECT DPA5/ADAPTER=3/VECTOR=%O154/CSR=%O4200
CONNECT DPA6/ADAPTER=3/VECTOR=%O154/CSR=%O4200
CONNECT DPA7/ADAPTER=3/VECTOR=%O154/CSR=%O4200
LOAD DM0:[1,11]RKDRIVER.EXE
CONNECT RKA0/ADAPTER=3/VECTOR=%O220/CSR=%O17400
CONNECT RKA1/ADAPTER=3/VECTOR=%O220/CSR=%O17400
LOAD DM0:[SYSEXE]GDDRIVER.EXE
CONNECT GDA0/ADAPTER=3/VECTOR=%O174/CSR=%O6000
CONNECT GDA1/ADAPTER=3/VECTOR=%O174/CSR=%O6000
CONNECT GDA2/ADAPTER=3/VECTOR=%O174/CSR=%O6000
$ !
$ !
$ ! Invoke system manager's installation-specific startup file.
$ !
$ ! MOUNT THE SECOND DM:  DMA1  :  X/XVII/MCMLXXVIII
$ MOUNT /SYSTEM DMA1: BATES
$ MOUNT /SYSTEM DPA0: THEA
$ MOUNT /SYSTEM DPA1: KRISTE
$ MOUNT /SYSTEM DPA2: TANYA
$ MOUNT /SYSTEM DPA3: WILLIA
$ MOUNT /SYSTEM DPA4: FRANCI
$ MOUNT /SYSTEM DPA5: THOMAS
$ MOUNT /SYSTEM DPA6: MICHAE
$ MOUNT /SYSTEM DPA7: KAREN
$ @[SYSMGR]SYSTARTUP.COM
$ !
$ ! System initialization complete
$ !
$ SET LOGIN /INTERACTIVE=16
$ !
$ !	DISABLE THE CONSOLE AS THE OPERATOR CONSOLE, SO THAT THE
$ !	PRINT QUEUE CAN BE SET UP FROM [SYSMGR]SYSTARTUP.COM.
$ ! DOESN'T SEEM TO WORK AS I EXPECTED.
$ !
$ !	XI/XVI/MCMLXXVII
$ !
$ ! REPLY/DISABLE
$ LOG/BRIEF
