	PROGRAM FXREFPRNT
C
C	THIS PROGRAM USES THE ALPHABETIZED CROSS REFERENCE FILE NAMED
C	'FXREFOUT.SRT' (PRODUCED BY SORTING FXREFOUT.DAT USING THE
C	SORT/RSX COMMAND IN 'FXREF.COM') TO OUTPUT A COMPACT
C	CROSS REFERENCE ON 'CROSSREF.MAP'.  'CROSSREF.LIS' IS A LINE NUMBERED
C	LISTING FILE OF THE INPUT TO PROGRAM FXREF.
C
C	J. THOMPSON  INTERMETRICS  FEBRUARY 16, 1979
C
	CHARACTER*23	STRING
	CHARACTER*80	LINE
C
	COMMON/FXREFD/	STRING,LINE
C
	OPEN(UNIT=1,NAME='FXREFOUT.SRT',TYPE='OLD',BLOCKSIZE=5632)
	OPEN(UNIT=2,NAME='CROSSREF.MAP',TYPE='NEW',
	1 CARRIAGECONTROL='LIST',BLOCKSIZE=5632)

C
	DO 100 J=1,80
100	LINE(J:J)=' '	!BLANK THE LINE
C	SET INDEX NUMBER (ONE BEFORE WHERE LINE NUMBER STARTS)
	INO=22
C	GET THE FIRST LINE
	READ(1,10,ERR=1100,END=1000) STRING
10	FORMAT(A23)
C	WRITE THE HEADING
	WRITE(2,30)
C	PUT NON-LINENUMBER STUFF IN LINE
300	LINE(1:1)=STRING(1:1)
	LINE(2:2)=' '
	LINE(3:18)=STRING(2:17)
C	PUT LINENO IN LINE
500	LINE(INO+1:INO+6)=STRING(18:23)
C	UPDATE INDEX NUMBER AND LEAVE ONE SPACE
	INO=INO+7
C	READ ANOTHER LINE
600	READ(1,10,ERR=1100,END=1000) STRING
C	TEST WHETHER LINE IS LONG ENOUGH TO OUTPUT YET
	IF(INO.GE.78) GO TO 800
C	TEST WHETHER NON-LINENUMBER STUFF HAS CHANGED YET
	IF(STRING(1:1).NE.LINE(1:1).OR.
	1 STRING(2:17).NE.LINE(3:18)) GO TO 800
C	SAME NAME, NOW TEST WHETHER THIS LINE NUMBER IS SAME AS LAST
	IF(STRING(18:23).EQ.LINE(INO-6:INO-1))GO TO 600
C	SAME NAME, DIFFERENT LINE NUMBER SO PUT LINENO IN LINE
	GO TO 500
C	WRITE LINE
800	IF(INO.GT.80) INO=80
	WRITE(2,20) LINE(1:INO)
20	FORMAT(A)
C	BLANK THE LINE
	DO 900 J=1,INO
900	LINE(J:J)=' '
C	RESET INDEX NUMBER
	INO=22
	GO TO 300
C	LAST WRITE
1000	WRITE(2,20) LINE(1:INO)
	CALL SETPRN !GET BACK USER NAME
	STOP '*** END FXREF PRINT ***'
1100	WRITE(6,*) '******** ERROR - FXREFOUT.SRT READ ERROR ********'
	STOP
30	FORMAT(' *****************************************',
	1 '***********************************',
	1 ////,10X,'INTERMETRICS FORTRAN IV CROSS REFERENCE PROGRAM',
	1 '  REV 1.0 VAX',
	2 //1H ,19X,'" = QUOTED STRING, # = NUMBER, $ = CROCK,'
	3 / 1H ,18X,'@ = IDENTIFIER (SYMBOL), H = HOLLERITH DATA',//)
	END
