	IMPLICIT INTEGER (A-Z)
	LOGICAL EOF
	CHARACTER*6 LIT377377
	CHARACTER*28 ENTRY
	CHARACTER*9 UFDNAME,SFDNAME,DUMMY,DISK
	CHARACTER*60 FULLDIRNAME
	CHARACTER*30 FULLSPEC,MFDNAME
	BYTE NAMELEN
	COMMON /CHARS/ENTRY,FULLSPEC
	COMMON /NUMERICS/FULLNDX,EOF,LENOFNAME,DATAOUT
	EQUIVALENCE (NAMELEN,ENTRY(4:4))
	DATA LIT377377/'377377'/
	DATA MFDIN/1/,UFDIN/2/,SFDIN/3/
C
C
C GET THE DISK TO LIST
C
	TYPE 5
5	FORMAT(' Enter disk to list (Dxn:) => '$)
	ACCEPT 15,DISK
15	FORMAT(A)
	MFDNAME=DISK//'[0,0]000000.DIR;1'
C
C OPEN THE MFD
C
	OPEN(UNIT=MFDIN,NAME=MFDNAME,READONLY,
	1TYPE='OLD',ERR=900)
C
C OPEN THE OUTPUT FILE
C
	DATAOUT=4
	OPEN(UNIT=DATAOUT,NAME='DIRALL.COM',TYPE='NEW',
	1CARRIAGECONTROL='LIST')
C
C READ THROUGH THE NUMERIC DIRECTORIES
C
10	READ(MFDIN,20,END=800,ERR=910)ENTRY
20	FORMAT(A)
	IF(ENTRY(5:10).LE.LIT377377) GOTO 10
C
C SEARCH THE MFD
C
100	FULLNDX=1
	FULLSPEC=' '
C
C LOOK FOR UFD IN MFD
C
	CALL FINDDIR(MFDIN,UFDNAME,DISK)
	FULLNDX=FULLNDX+LENOFNAME
C
C IF EOF FOUND - DONE
C
	IF(EOF) GO TO 800
C
C OPEN UFD TO LOOK FOR SUBDIRECTORIES
C
	FULLDIRNAME=DISK//'[0,0]'//UFDNAME//'.DIR'
	OPEN(UNIT=UFDIN,NAME=FULLDIRNAME,READONLY,TYPE='OLD',ERR=920)
	SFD1NDX=FULLNDX
C
C LOOK FOR UFD IN SFD
C
210	FULLNDX=SFD1NDX
	CALL FINDDIR(UFDIN,SFDNAME,DISK)
	FULLNDX=FULLNDX+LENOFNAME+1
C
C IF NOT EOF - LOOK FOR MORE SFD
C
	IF(.NOT.EOF) GO TO 300
C
C EOF - CLOSE THIS UFD
C
220	CLOSE(UNIT=UFDIN)
C
C LOOK FOR NEXT UFD IN MFD
C
	GO TO 100
C
C OPEN SFD TO LOOK FOR SUB-SFD
C
300	FULLDIRNAME=DISK//'['//UFDNAME//']'//SFDNAME//'.DIR'
	OPEN(UNIT=SFDIN,NAME=FULLDIRNAME,READONLY,TYPE='OLD',ERR=930)
	SFD2NDX=FULLNDX
C
C LOOK IN SFD FOR SUB-SFD
310	FULLNDX=SFD2NDX
	CALL FINDDIR(SFDIN,DUMMY,DISK)
C
C IF NOT EOF - LOOK FOR MORE SUB-SFD
C
	IF(.NOT.EOF) GO TO 310
C
C EOF - DONE WITH SFD
C
	CLOSE(UNIT=SFDIN)
C
C LOOK FOR NEXT SFD IN UFD
C
	GO TO 210
C
C MFD EOF
C
800	CONTINUE
890	CALL EXIT
C
C ERRORS
C
900	TYPE 901
901	FORMAT(' FAILED TO OPEN MFD')
	GO TO 890
910	TYPE 911
911	FORMAT(' READ FAILED')
	GO TO 890
920	TYPE 921,FULLDIRNAME
921	FORMAT(' FAILED TO OPEN UFD ',A)
	GO TO 220
930	TYPE 931,FULLDIRNAME
931	FORMAT(' FAILED TO OPEN SFD ',A)
	GO TO 890
	END
	SUBROUTINE FINDDIR(INLUN,DIRNAME,DISK)
	IMPLICIT INTEGER (A-Z)
	LOGICAL EOF
	CHARACTER*28 ENTRY
	CHARACTER*30 FULLSPEC
	CHARACTER*9 DIRNAME,DISK
	BYTE NAMELEN
	EQUIVALENCE (NAMELEN,ENTRY(4:4))
	COMMON /CHARS/ENTRY,FULLSPEC
	COMMON /NUMERICS/FULLNDX,EOF,LENOFNAME,DATAOUT
	DATA DIRCNT/1/
	EOF=.FALSE.
10	CONTINUE
	READ(INLUN,20,END=800,ERR=900)ENTRY
20	FORMAT(A)
	ENDOFNAMENDX=NAMELEN+4
	TYPENDX=ENDOFNAMENDX-2
	IF(ENTRY(TYPENDX:ENDOFNAMENDX).NE.'DIR') GO TO 10
	LENOFNAME=NAMELEN-4
	DIRNAME=ENTRY(5:5+LENOFNAME-1)
	IF(FULLNDX.EQ.1)FULLSPEC=ENTRY(5:5+LENOFNAME-1)
	IF(FULLNDX.NE.1)FULLSPEC=FULLSPEC(1:FULLNDX-1)
	1//'.'//ENTRY(5:5+LENOFNAME-1)
	IF(FULLNDX.EQ.1) LAST=FULLNDX+LENOFNAME-1
	IF(FULLNDX.NE.1) LAST=FULLNDX+LENOFNAME
	IF(DIRCNT.LT.1000) ENCODE(3,101,DIRSTR)DIRCNT
	IF(DIRCNT.LT.100)  ENCODE(3,102,DIRSTR)DIRCNT
	IF(DIRCNT.LT.10)   ENCODE(3,103,DIRSTR)DIRCNT
101	FORMAT(I3)
102	FORMAT('0',I2)
103	FORMAT('00',I1)
	NCHAR=INDEX(DISK,' ')-1  !FIND BLANK AFTER DISK NAME
	IF(NCHAR.LE.0) NCHAR=1
	WRITE(DATAOUT,30)DIRSTR,DISK(1:NCHAR),FULLSPEC(1:LAST)
30	FORMAT('$MCR PIP DIRECT.',A3,'=',A,'[',A,']/TB')
	DIRCNT=DIRCNT+1
	RETURN
C
C EOF FOUND
C
800	EOF=.TRUE.
	RETURN
C
C ERROR
C
900	TYPE 901
901	FORMAT(' READ ERROR')
	RETURN
	END
