	! File: SYS$LIBRARY:SIGDEF.FOR - FORTRAN INCLUDE file 
	! to define system signaling and condition handling symbols.  Version 1-0.

	PARAMETER
	1 SS$_ACCVIO    = '000C'X,	! ACCESS VIOLATION
	1 SS$_OPCCUS	= '0434'X,	! OPCODE RESERVED TO CUSTOMER
	1 SS$_OPCDEC	= '043C'X,	! OPCODE RESERVED TO DIGITAL
	1 SS$_RADRMOD	= '044C'X,	! RESERVED ADDRESSING MODE
	1 SS$_ROPRAND   = '0454'X, 	! RESERVED OPERAND
	1 SS$_FAIL	= '045C'X,	! SYSTEM SERVICE FAILURE
	1 SS$_TBIT	= '0464'X	! T-BIT TRAP

	PARAMETER
	1 SS$_INTOVF	= '047C'X,	! INTEGER OVERFLOW
	1 SS$_INTDIV	= '0484'X,	! INTEGER DIVIDE BY ZERO
	1 SS$_FLTOVF	= '048C'X,	! FLOATING OVERFLOW
	1 SS$_FLTDIV	= '0494'X,	! FLOATING/DECIMAL DIVIDE BY ZERO
	1 SS$_FLTUND	= '049C'X,	! FLOATING UNDERFLOW
	1 SS$_DECOVF	= '04A4'X,	! DECIMAL OVERFLOW
	1 SS$_SUBRNG	= '04AC'X	! SUBSCRIPT OUT OF RANGE

	PARAMETER
	1 SS$_NORMAL    = '0001'X 	! NORMAL COMPLETION

	PARAMETER
	1 SS$_CONTINUE  = '0001'X,	! CONTINUE EXECUTION AT POINT OF EXCEPTION
	1 SS$_RESIGNAL  = '0918'X,	! RESIGNAL CONDITION TO NEXT HANDLER
	1 SS$_UNWIND    = '0920'X 	! UNWIND CONDITION

