C ***	TPIN - THIS PROGRAM WILL COPY AN INPUT TAPE INTO A USER-SPECIFIED
C	       FILE.  SEE TPIN.HLP FOR DOCUMENTATION.
C
C	J. THOMPSON  NOVEMBER 15, 1978
C	BUSY TEST ADDED JANUARY 23, 1979
C
C
	IMPLICIT INTEGER*2 (I-O)
C
	CHARACTER	IB*24000
C
	INTEGER*4 IO$_SKIPFILE,IO$_READLBLK,IO_$WRITELBLK,IO$_WRITEOF,
     1	IO$_REWIND,SS$_ENDOFFILE,SS$_ENDOFTAPE,SS$_NORMAL
	EXTERNAL IO$_SKIPFILE,IO$_READLBLK,IO$_WRITELBLK,IO$_WRITEOF,
     1	IO$_REWIND,SS$_ENDOFFILE,SS$_ENDOFTAPE,SS$_NORMAL
	INTEGER*4 SYS$ASSIGN,SYS$QIOW,RETCODE,FLENGTH,IBUF4(6000)
	INTEGER*4 RCOUNT
C
	COMMON/AAA/	IBUF(12000),IOSB(4)
	COMMON/BBB/	IFILE,NSKIP,LREC,LRECB
	EQUIVALENCE (IBUF(1),IBUF4(1),IB)
C
	CHARACTER	OUTFILE*13	!FILENAME GOES HERE
C
	BUSY=0		!TAPE NOT INITIALIZED WHEN ZERO
	IFILE=0		!INPUT FILE COUNTER
C
	WRITE(6,*) 'INTERMETRICS TAPE-TO-DISK COPY PROGRAM (REV 0.0)'
	WRITE(6,*) 'INPUT TAPE LOGICAL NAME SHOULD BE "ITAPE"'
90	WRITE(6,*) ' TYPE # OF FILES TO SKIP ON INPUT TAPE.'
	WRITE(6,*) ' (USE NEGATIVE VALUE TO STOP PROGRAM.)'
	READ(5,11) NSKIP
	NSTOP=NSKIP+IFILE
	IF(NSKIP.LT.0) GO TO 700
11	FORMAT(I3)
C	GET THE FILENAME FOR OUTPUT
	WRITE(6,*) ' TYPE "FILENAME.TYP" FOR OUTPUT'
	READ(5,10) OUTFILE
10	FORMAT(A)
	WRITE(6,*) ' TYPE 1 TO DEBLANK RHS OF EACH RECORD.'
	READ(5,11) IDEBLANK
C	OPEN OUTPUT FILE
	OPEN(UNIT=1,NAME=OUTFILE,CARRIAGECONTROL='LIST')
95	WRITE(6,*) ' TYPE RECORDSIZE IN BYTES (EVEN NUMBER PLEASE)'
	READ(5,11) LRECB
	LREC=LRECB/2	!RECORDSIZE IN 16 BIT WORDS
	IF(LREC.LE.0) GO TO 95
C	GET TAPE CHANNEL ASSIGNMENTS
	IF(BUSY.EQ.1) GO TO 97	!DON'T WANT TO REASSIGN TAPE
	RETCODE=SYS$ASSIGN('ITAPE',ICHAN,,)
	IF(RETCODE.NE.%LOC(SS$_NORMAL)) STOP 'ITAPE NOT ASSIGNED'
	BUSY=1		!INDICATE TAPE HAS BEEN ASSIGNED
C
97	RCOUNT=1	!RECORD NUMBER
	FLENGTH=0	!LENGTH OF FILE IN BYTES
C
C	SKIP INPUT FILES SECTION
C
	ISKIP=1	!SKIP ONE FILE AT A TIME
100	IF(IFILE.EQ.NSTOP) GO TO 400
	RETCODE=SYS$QIOW(,%VAL(ICHAN),%VAL(%LOC(IO$_SKIPFILE)),IOSB,,,
     1	%VAL(ISKIP),,,,,)	!SPACE OVER FILE
	IFILE=IFILE+1
	IF(RETCODE.EQ.%LOC(SS$_NORMAL)) GO TO 100	!TEST FOR OK
	WRITE(6,3) IOSB(1)	!PROBLEMS
3	FORMAT(1H ,'HEXIDECIMAL # OF ERROR = ',Z8)
	STOP 'INPUT SKIPPING PROBLEMS'
C
C	READ/WRITE LOOP
C
400	NBYTES=24000
	RETCODE=SYS$QIOW(,%VAL(ICHAN),%VAL(%LOC(IO$_READLBLK)),IOSB,,,
     1	IBUF,%VAL(NBYTES),,,,)
C	THE FOLLOWING TWO STATEMENTS ARE FOR ERROR CHECKING
C	WRITE(6,12) IFILE,IOSB(1),IOSB(2)
C12	FORMAT(1H ,I5,2X,Z5,2X,I8)
	IF(IOSB(1).EQ.%LOC(SS$_ENDOFFILE)) GO TO 500
	IF(IOSB(1).EQ.%LOC(SS$_ENDOFTAPE)) GO TO 500
	IF(IOSB(1).NE.%LOC(SS$_NORMAL)) GO TO 470	!TEST FOR ERROR
430	NBYTES=IOSB(2)	!GET CORRECT # OF BYTES READ
C	DEBLOCK AND WRITE TAPE BUFFER
	NREC=NBYTES/LRECB	!NUMBER OF RECORDS TO OUTPUT
	WRITE(6,*) RCOUNT,'  # BYTES = ',NBYTES,' # RECORDS = ',NREC
	RCOUNT=RCOUNT+NREC	!INCREMENT START RECORD
C	MASK OUT PARITY
	NWORDS=NBYTES/2
	DO 335 I=1,NWORDS
335	IBUF(I)=IBUF(I).AND.'77577'O
	DO 440 I=1,NBYTES,LRECB
	ISTART=I
	LAST=I+LRECB-1
	IF(IDEBLANK.NE.1) GO TO 440
C	DEBLANK RHS EACH LINE
	DO 435 L=1,LRECB
	M=LAST+1-L
	IF(IB(M:M).NE.' ') GO TO 436
435	CONTINUE
C	NOW DONE WITH DEBLANKING
436	LAST=M
	IF(LAST.LT.ISTART) LAST=ISTART
440	WRITE(1,13,ERR=450)	IB(ISTART:LAST)
13	FORMAT(A)
	FLENGTH=FLENGTH+NBYTES	!COUNT NUMBER OF BYTES IN FILE
	GO TO 400
450	WRITE(6,*)	'OUTPUT PROBLEMS'
	GO TO 500
470	WRITE(6,3) IOSB(1)	!PROBLEMS
	WRITE(6,*)	'INPUT PROBLEMS'
C	TEST FOR END OF VOLUME
	IF(IOSB(2).LE.0)
     1	   WRITE(6,*) 'ZERO BYTE COUNT MUST MEAN END-OF-VOL ON INPUT'
	IF(IOSB(2).LE.0) GO TO 500
C	ATTEMPT TO RECOVER INPUT DATA
	WRITE(6,8) IOSB(2)
8	FORMAT(1H ,I5,' BYTE COUNT - TYPE: 0=STOP,1=USE PRESENT BYTE'/
     1	' COUNT, ELSE=VALUE TO BE USED FOR BYTE COUNT (FORMAT I5)')
	INERR=0
	READ(5,9) INERR
9	FORMAT(I5)
	IF(INERR.EQ.0) GO TO 500
	IF(INERR.EQ.1) GO TO 430
	IOSB(2)=INERR
	GO TO 430
C
C	END OF FILE FOUND OR END OF TAPE OR STOP DESIRED
C
500	WRITE(6,7) IFILE,FLENGTH
7	FORMAT(' INFILE',I5,3X,'COPIED TO DISK FILE.  FILE-LENGTH = ',
     1	   I10)
	IFILE=IFILE+1	!INCREMENT FILE COUNT
	CLOSE(UNIT=1,DISPOSE='KEEP')
	GO TO 90	!LOOP FOR MORE FILES
C
C	ALL DONE - CLEAN UP
700	RETCODE=SYS$QIO(,%VAL(ICHAN),%VAL(%LOC(IO$_REWIND)),,,,,,,,,)
	STOP
	END
